<script setup lang="ts">
import { PropType } from 'vue';
import { types, purposes, origins } from '~/models/licence';
const props = defineProps({
  name: { type: String, required: false, default: 'Lorem ipsum' },
  slug: { type: String, required: false, default: 'Lorem' },
  summary: { type: String, required: false, default: '' },
  pros: {
    type: Array,
    required: false,
    default: () => [
      'Lorem ipsum Sed sit amet ligula pretium',
      'feugiat enim eget, dictum lectus. Sed tempor risus imperdiet magna tristique congue. Sed sit amet ligula pretium',
      'feugiat enim eget, dictum lectus. Sed tempor risus imperdiet magna tristique congue.',
    ],
  },
  cons: {
    type: Array,
    required: false,
    default: () => [
      'Sed sit amet ligula pretium, feugiat enim eget, dictum lectus. Sed tempor risus imperdiet magna tristique congue. Vestibulum bibendum dapibus gravida. Nam at tempor dolor. Sed tempor risus imperdiet magna tristique.Sed sit amet ligula pretium',
      'feugiat enim eget, dictum lectus. Sed tempor risus imperdiet magna tristique congue. Vestibulum bibendum dapibus gravida.',
    ],
  },
  type: { type: Array as PropType<Array<string>>, required: false, default: () => ['Permissive'] },
  origin: { type: Array as PropType<Array<string>>, required: false, default: () => ['Communautaire'] },
  purpose: { type: Array as PropType<Array<string>>, required: false, default: () => ['Logiciels'] },
  projetName: { type: String, required: false, default: '' },
  projetLink: { type: String, required: false, default: '' },
  projetImg: { type: String, required: false, default: '' },
});
const config = useRuntimeConfig();
const href = ref('');
let imgSrc = props.projetImg && `${config.public.directus.url}/assets/${props.projetImg}`;
onMounted(() => {
  href.value =
    'mailto:?subject=Licence%20Libre&body=Voici%20le%20lien%20:' +
    window.location.origin +
    '/licence-libre/le-point-sur-les-licences-libres/' +
    props.slug;
});
</script>
<template>
  <div class="licence anct-box-shadow">
    <div class="fr-grid-row fr-pl-6w fr-pr-6w fr-pt-8w anct-bg-white">
      <div class="licence__description fr-col-lg-5">
        <div class="licence__tags">
          <h1 class="fr-h2">{{ name }}</h1>
          <div class="fr-pb-4v">
            <div class="licence__tags--title fr-text--bold">Type de licence :</div>
            <template v-for="(t, index) in types" :key="`type--${index}`">
              <button v-if="type" class="tag fr-m-2v fr-pl-1-5v fr-pr-1-5v fr-pt-0-5v fr-pb-0-5v fr-text--sm" :disabled="!type.includes(t)">
                <span v-if="!type.includes(t)" class="fr-mr-1v fr-fi-close-line" aria-hidden="true"></span>
                <span v-if="type.includes(t)" class="fr-mr-1v fr-icon-success-fill" aria-hidden="true"></span>
                {{ t?.toUpperCase() }}
              </button>
            </template>
          </div>
          <div class="fr-pb-4v">
            <div class="licence__tags--title fr-text--bold">Origine de la licence :</div>
            <template v-for="(o, index) in origins" :key="`origin--${index}`">
              <button
                v-if="origin"
                class="tag fr-m-2v fr-pl-1-5v fr-pr-1-5v fr-pt-0-5v fr-pb-0-5v fr-text--sm"
                :disabled="!origin.includes(o)"
              >
                <span v-if="!origin.includes(o)" class="fr-mr-1v fr-fi-close-line" aria-hidden="true"></span>
                <span v-if="origin.includes(o)" class="fr-mr-1v fr-icon-success-fill" aria-hidden="true"></span>
                {{ o?.toUpperCase() }}
              </button>
            </template>
          </div>
          <div class="fr-pb-4v">
            <div class="licence__tags--title fr-text--bold">Adaptée pour :</div>
            <template v-for="(p, index) in purposes" :key="`purpose--${index}`">
              <button
                v-if="purpose"
                class="tag fr-m-2v fr-pl-1-5v fr-pr-1-5v fr-pt-0-5v fr-pb-0-5v fr-text--sm"
                :disabled="!purpose.includes(p)"
              >
                <span v-if="!purpose.includes(p)" class="fr-mr-1v fr-fi-close-line" aria-hidden="true"></span>
                <span v-if="purpose.includes(p)" class="fr-mr-1v fr-icon-success-fill" aria-hidden="true"></span>
                {{ p?.toUpperCase() }}
              </button>
            </template>
          </div>
        </div>
        <div v-if="projetName" class="licence__exemple fr-pb-8w fr-pr-4w">
          <h5 class="licence__exemple--title fr-h5">Exemple :</h5>
          <div class="licence__exemple--content">
            <img v-if="imgSrc" :src="imgSrc" class="fr-pr-2w" />
            <img v-else src="/img/projet_example.jpg" class="fr-pr-2w" />
            <div class="fr-mb-2v">
              Le projet "{{ projetName }}" a utilisé la licence
              <strong>{{ name }}</strong>
            </div>
          </div>
          <a class="fr-text--xs" :href="projetLink" target="_blank"
            ><span class="fr-fi-arrow-right-line" aria-hidden="true"></span> Voir le projet</a
          >
        </div>
      </div>
      <div class="fr-col-offset-1"></div>
      <div class="licence__details fr-col-lg-6">
        <div class="licence__details--summary fr-pb-3w fr-text--bold">
          {{ summary }}
        </div>
        <div>
          <h3>Les avantages :</h3>
          <ul>
            <li v-for="(pro, index) in pros" :key="`pro--${index}`">
              <div class="licence-pro__item">
                <div class="fr-pr-2v">
                  <img src="/img/pro.svg" alt="" />
                </div>
                <p>{{ pro }}</p>
              </div>
            </li>
          </ul>
        </div>
        <div>
          <h3>Les inconvénients :</h3>
          <ul>
            <li v-for="(con, index) in cons" :key="`con--${index}`">
              <div class="licence-con__item">
                <div class="fr-pr-2v">
                  <img src="/img/con.svg" alt="" />
                </div>
                <p>{{ con }}</p>
              </div>
            </li>
          </ul>
        </div>
        <div class="licence__details--button fr-pt-4w fr-pb-8w">
          <a class="fr-btn" :href="href" target="_blank"> Je partage cette fiche par mail</a>
        </div>
      </div>
    </div>
    <div class="share__link">
      <div class="fr-grid-row fr-grid-row--center fr-pt-6w fr-pb-4w">
        <span class="fr-col-6 fr-text--lg anct-text-white">
          Maintenant que vous avez choisi une licence, vous trouverez la méthodologie à suivre pour la mettre en place en cliquant sur le
          bouton ci-dessous.
        </span>
      </div>
      <div class="anct-text-center">
        <NuxtLink
          to="https://www.data.gouv.fr/fr/pages/legal/licences/"
          target="_blank"
          class="fr-btn fr-text--sm fr-mb-6w anct-bg-low-blue"
        >
          <span class="anct-text-blue">Consulter la documentation Github</span>
          <span class="fr-fi-external-link-line anct-text-blue" aria-hidden="true"></span>
        </NuxtLink>
      </div>
    </div>
  </div>
</template>
<style lang="scss">
.licence {
  .licence-pro__item,
  .licence-con__item {
    display: flex;
  }
  ul {
    list-style-type: none;
    padding-inline-start: 0;
  }
  .licence__tags--title {
    font-size: 20px;
  }
  .licence__details--summary {
    font-size: 22px;
    color: #929292;
  }
  .licence__description,
  .licence__details > div {
    position: relative;
    display: flex;
    flex-wrap: wrap;
  }
  .licence__exemple,
  .licence__details--button {
    position: absolute;
    bottom: 0px;
  }

  .licence__exemple {
    a[target='_blank']::after {
      display: none;
    }
  }
  .licence__exemple--content {
    min-width: 320px;
    img {
      float: left;
    }
  }
  .tag {
    flex-direction: row;
    width: fit-content;

    border-radius: 0.5rem;
    color: white;
    background: #000091;

    justify-content: center;
    line-height: 1.5rem;

    &:hover,
    &:active {
      background: #000091;
      cursor: text;
      outline-style: none;
    }
    &:disabled {
      color: white;
      background-color: #cecece;
    }
  }
  .share__link {
    background-color: #000091;
    .fr-btn[target='_blank']::after {
      display: none;
    }
    .fr-fi-external-link-line {
      &::before {
        --icon-size: 1rem;
      }
      padding-left: 0.5rem;
    }
  }
}
@media screen and (max-width: 999px) {
  .licence {
    .licence__exemple,
    .licence__details--button {
      position: static;
    }
  }
}
</style>
